;key.asm

;
check_key:
   halt
   call GET_KEY
   push ix
   ld ix,key_tbl
   ld c,a
   ld b,0
   add ix,bc
   add ix,bc
   ld h,(ix+1)
   ld l,(ix)
   pop ix
   jp (hl)
   
;
null_r:
   ret

;
enter:
   ld hl,(mode_srvc)
   jp (hl)

;
quit:
   ld a,1
   ld (quit_flag),a
   call cleanup
   ret

;
left:
   ld bc,-1
   jp add_cur_bc

;
right:
   ld bc,1
   jp add_cur_bc

;
down:
   ld bc,bytes_line
   jp add_cur_bc

;
up:
   ld bc,-bytes_line
   jp add_cur_bc

;
down_C:
   ld bc,C
   jp add_cur_bc

;
up_C:
   ld bc,-C
   jp add_cur_bc

;
down_M:
   ld bc,M
   jp add_cur_bc

;
up_M:
   ld bc,-M
   jp add_cur_bc

;
f1:
   ld a,(ROM_page)
   dec a
   and $F
   ld (ROM_page),a
   call pop_pages
   call show_screen
   ret

;
f2:
   ld a,(ROM_page)
   inc a
   and $F
   ld (ROM_page),a
   call pop_pages
   call show_screen
   ret

;
f3:
   ld a,(mode)
   inc a
   cp 3
   jr nz,f31
   ld a,0
f31: ld (mode),a
   call show_mode_line
   ret

;
f4:
   ld a,(RAM_page)
   dec a
   and $7
   ld (RAM_page),a
   call pop_pages
   call show_screen
   ret

;
f5:
   ld a,(RAM_page)
   inc a
   and $7
   ld (RAM_page),a
   call pop_pages
   call show_screen
   ret

;
second:
   ld a,(emode)
   inc a
   cp 3
   jr nz,s1
   ld a,0
s1: ld (emode),a
   call upd_emode
   ret

;
alpha:
   ld a,Lquote
   jp add_string_char

;
other:
   ld hl,(em_char_tbl)
   add a,-$A
   ld c,a
   ld b,0
   add hl,bc
   ld a,(hl)
   cp '-'
   ret z
   jp add_string_char

;
clear:
   ld hl,0
   ld (cur_str_pos),hl
   ld hl,e_string-1
   ld b,max_em_str_len+1
   ld a,0
c0: inc hl
   ld (hl),a
   djnz c0
   ld hl,$0007
   ld (_curRow),hl
   ld hl,blank_line
   call _puts
   ret

;
delete:  ;delete a character from e_string
   ld hl,(cur_str_pos)
   ld a,l
   cp 0
   ret z
   
   push hl
   ld bc,e_string
   add hl,bc
   dec hl
   ld a,0
   ld (hl),a
   pop hl
   
   dec hl
   ld (cur_str_pos),hl
   ld hl,$0007
   ld (_curRow),hl
   ld hl,blank_line
   call _puts
   ld hl,$0007
   ld (_curRow),hl
   ld hl,e_string
   call _puts
   ret
